#define MCCI_MAX_RETURN_TEXT	1024

#define MCCI_OK			0
#define MCCI_FAIL		1
#define MCCI_OUTOFMEMORY	2
#define MCCI_REQUEST_FAIL	3
#define MCCI_NETWORK_ERROR	4

#define MCCI_DEFAULT		0
#define MCCI_OUTPUT_NONE	100
#define MCCI_OUTPUT_CURRENT	101
#define MCCI_OUTPUT_NEW		102
#define MCCI_ABSOLUTE		110
#define MCCI_RELATIVE		111

#define MCCI_S_GET		"GET"
#define MCCI_S_DISPLAY		"DISPLAY"
#define MCCI_S_DISCONNECT	"DISCONNECT"
#define MCCI_S_QUIT		"QUIT"
#define MCCI_S_SEND		"SEND"
#define MCCI_S_OUTPUT		"OUTPUT"
#define MCCI_S_ANCHOR		"ANCHOR"
#define MCCI_S_TO		"TO"
#define MCCI_S_STOP		"STOP"
#define MCCI_S_CURRENT		"CURRENT"
#define MCCI_S_NEW		"NEW"
#define MCCI_S_NONE		"NONE"
#define MCCI_S_HEADER		"HEADER"

#define MCCIR_OK		200
#define MCCIR_GET_OK		210
#define MCCIR_DISPLAY_OK	211
#define MCCIR_DISCONNECT_OK	212
#define MCCIR_QUIT_OK		213
#define MCCIR_SEND_OUTPUT_OK	214
#define MCCIR_SEND_O_STOP_OK	215
#define MCCIR_SEND_ANCHOR_OK	216
#define MCCIR_SEND_A_STOP_OK	217

#define MCCIR_ANCHOR_INFO	301
#define MCCIR_SEND_DATA_OUTPUT	302

#define MCCIR_UNRECOGNIZED	401  /* what's this? */
#define MCCIR_ERROR		402  /* does not follow protocol */

#define MCCIR_REQ_FAILED	500  /* request failed */
#define MCCIR_GET_FAILED	501  /* request failed */

#include "port.h"
typedef PortDescriptor *MCCIPort;

/* ccibind1.c */
#include <X11/Intrinsc.h>
#include "mosaic.h"

extern void MoCCISendAnchor(MCCIPort client, int sendIt);
extern void MoCCISendAnchorToCCI(char *url);
extern int MoCCIInitialize(int portNumber);
extern int MoCCITerminateAllConnections();
extern int MoCCITerminateAConnection(MCCIPort client);
extern void MoCCIHandleInput(MCCIPort client, int *source, XtInputId* inputID);
extern void MoCCINewConnection(XtAppContext app_context,
                               int *source,
                               XtInputId *inputID);
extern mo_status MoDisplayCCIWindow(mo_window *win);
extern void MoCCISendOutputToClient(char *contentType, char *fileName);
extern void MoCCISendOutput(MCCIPort client,Boolean sendIt,char *contentType);
extern void MoCCIStartListening(Widget w,int port);

/* ccibind2.c */

extern void MCCIRequestGetURL(int *retCode, char *retText,
                       char *url, int output,char *additionalHeader);
extern void MCCIRequestSendAnchor(int *retCode, char *retText,
                           MCCIPort client, int on);
extern void MCCIRequestSendOutput(int *retCode, char *retText, MCCIPort client,
                           int on, char *type);

/* cciserve.c */

extern int MCCIReturnListenPortSocketDescriptor();
extern MCCICloseConnection(MCCIPort clientPort);
extern MCCICloseAcceptPort();
extern int MCCIServerInitialize(int portNumber);
extern int MCCIGetSocketDescriptor(MCCIPort clientPort);
extern MCCIPort MCCICheckAndAcceptConnection();
extern int MCCISendResponseLine(MCCIPort client,int code,char *text);
extern int MCCIIsThereInput(MCCIPort client);
extern int MCCIReadContent(MCCIPort client,char **content);
extern int MCCIHandleSend(MCCIPort client,char *line,char *retText);
extern int MCCIHandleGet(MCCIPort client,char *line,char *retText);
extern char MCCIHandleInput(MCCIPort client);
extern MCCISendAnchorHistory(MCCIPort client,char *url);
extern int MCCISendOutputFile(MCCIPort client,char *contentType,
                              char *fileName);
